using System;
using System.IO;

namespace UnrealBuildTool.Rules
{
    public class LynxOpenXRHMD : ModuleRules
    {
        public LynxOpenXRHMD(ReadOnlyTargetRules Target) : base(Target)
        {
            PrivateIncludePaths.AddRange(
                new string[] {
                    EngineDirectory + "/Plugins/Runtime/OpenXR/Source/OpenXRHMD/Private",
                    EngineDirectory + "/Source/Runtime/Renderer/Private",
                    EngineDirectory + "/Source/Runtime/OpenGLDrv/Private",
                    EngineDirectory + "/Source/Runtime/VulkanRHI/Private",
                    EngineDirectory + "/Source/Runtime/Engine/Classes/Components",
                    EngineDirectory + "/Source/Runtime/Engine/Classes/Kismet",
                    EngineDirectory + "/Source/Runtime/VulkanRHI/Private/Android",
                    EngineDirectory + "/Source/ThirdParty/OpenXR/include",
                    "LynxOpenXR/Private",
                });

            PublicIncludePathModuleNames.AddRange(
                new string[] {
                    "Launch",
                    "OpenXRHMD",
                });

            PrivateDependencyModuleNames.AddRange(
                new string[]
                {
                    "Core",
                    "CoreUObject",
                    "Engine",
                    "InputCore",
                    "RHI",
                    "RenderCore",
                    "Renderer",
                    "Slate",
                    "SlateCore",
                    "ImageWrapper",
                    "MediaAssets",
                    "Analytics",
                    "OpenGLDrv",
                    "VulkanRHI",
                    "HeadMountedDisplay",
                    "Projects",
                    "OpenXRHMD",
                });


            if (Target.bBuildEditor == true)
            {
                PrivateDependencyModuleNames.Add("UnrealEd");
            }

            AddEngineThirdPartyPrivateStaticDependencies(Target, "OpenGL");
            AddEngineThirdPartyPrivateStaticDependencies(Target, "OpenXR");

            if (Target.Platform == UnrealTargetPlatform.Android)
            {
                // Vulkan
                {
                    AddEngineThirdPartyPrivateStaticDependencies(Target, "Vulkan");
                }
                // AndroidPlugin
                {
                    string PluginPath = Utils.MakePathRelativeTo(ModuleDirectory, Target.RelativeEnginePath);
                    AdditionalPropertiesForReceipt.Add("AndroidPlugin", Path.Combine(PluginPath, "LynxOpenXRHMD.xml"));
                }
            }
        }
    }
}